#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define int ll
using pii = pair<int, int>;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n * 28);
    vector<int> cnt(n * 28);
    set<int> used;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        map<char, int> mp;
        int prev = -1;
        for (int j = 0; j < s.size(); j++) {
            int cur = mp[s[j]];
            cur = cur * 26 + s[j] - 'a';
            used.insert(cur);
            mp[s[j]]++;
            if (prev != -1) {
                g[prev].push_back(cur);
                cnt[cur]++;
            }
            prev = cur;
        }
    }

    set<pair<pii, int>> all;
    vector<int> pp[27];
    string t;
    cin >> t;
    for (int i = 0; i < t.size(); i++) {
        pp[t[i] - 'a'].push_back(i);
    }
    
    for (int i: used) {
        int pos = -1;
        if (pp[i % 26].size()) {
            pos = pp[i % 26].back();
            // cerr << char(i % 26 + 'a') << " " << pos << endl;
        }; 
        all.insert(pair{pii{cnt[i], -pos}, i});
    }

    vector<int> order;
    string ans = "";
    while (!all.empty()) {
        auto [px, v] = *all.begin();
        all.erase(all.begin());
        ans += char(v % 26 + 'a');
        auto [c, pos] = px;
        cerr << "used " << c << " " << pos << " " << v / 26 << " " << char(v % 26 + 'a') << endl; 
        if (c != 0) {
            return;
        }

        if (pos <= 0) {
            order.push_back(-pos);
        }

        for (auto i: g[v]) {
            int pos = -1; 
            if (pp[i % 26].size()) {
                pos = pp[i % 26].back();
            };
            all.erase(pair{pii{cnt[i], -pos}, i});
            cnt[i]--;
            all.insert(pair{pii{cnt[i], -pos}, i});
        }
    }
    if (is_sorted(order.begin(), order.end())) {
        cout << "NO";
    } else {
        cout << "YES\n" << ans << "\n";
    }
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int tt = 1;
    // cin >> tt;
    for (int t = 0; t < tt; t++) {
        solve();
    }
    return 0;
}